#include <hmg.ch>
 
Function Main
   local cFontName := 'Arial'
   local nFontSize := 12
   private aKeys := {}
   private aData := {}
   private nCount := 0
   public oDB
   public aColorTable := { 255, 255, 200 }
   public aColorProperties := { 200, 255, 200 }
   public aTabPages := {}
   private nDesktopWidth := GetDesktopWidth()
   private nDesktopHeight := GetDesktopHeight() - 60
   define window main at 0, 0 width nDesktopWidth height nDesktopHeight main nosize
      define button selectfile
         row 10
         col 10
         width 120
         caption 'Browse JSON File'
         action selectjson()
      end button
      define button navigate
         row 10
         col 140
         width 120
         caption 'Navigate JSON'
         action navigatejson()
      end button
      define editbox jsontext
         row 40
         col 10
         width nDesktopWidth - 20
         height 150
         hscrollbar .f.
      end editbox
      define tab json at 200, 10 width nDesktopWidth - 20 height nDesktopHeight - 240
      end tab
//      on key escape action main.release
   end window      
   // page name, parentid, tabcount
//   aadd( aTabPages, { 'Root', 0, 1 } )
  Main.Activate

Return

function selectjson
   local aContent
   local cValue := ''
   local i := 0
   cFile := getfile( { { 'JSON Files (*.json)', '*.json' }, { 'All Files (*.*)', '*.*' } }, 'Open JSON File...' )
   if file( cFile )
      main.jsontext.value := memoread( cFile ) 
      main.json.release
      define tab json parent main at 200, 10 width nDesktopWidth - 20 height nDesktopHeight - 240 
      end tab
      asize( aTabPages, 0 )
   endif
   
function navigatejson   
   local aTable := {}
   local i := 0
   
   if file( 'json_temp.sqlite' )
      ferase( 'json_temp.sqlite' )
   endif   
   oDB := connect2db( 'json_temp.sqlite', .t. )
   if oDB == nil
      msgstop( 'DB can not be created!' )
      return nil
   endif
   // create json table
   miscsql( oDB, 'drop TABLE if exists jsoncontent' )      
   miscsql( oDB, 'CREATE TABLE jsoncontent( key ANY, value ANY, type TEXT, atom ANY, id INTEGER, parent INTEGER, fullkey TEXT, path TEXT )' )      
   miscsql( oDB, "insert into jsoncontent select * from json_tree( '" + main.jsontext.value  + "' )" ) 
   main.json.release
   define tab json parent main at 200, 10 width nDesktopWidth - 20 height nDesktopHeight - 240 
   end tab
   asize( aTabPages, 0 )
   // get root!
   aTable := sql( oDB, 'select key, value, type, id, parent from jsoncontent where id = 0' )
   if hmg_len( aTable ) > 0
      if aTable[ 1, 3 ] == 'array'
         showtable( 0 )
      endif
      if aTable[ 1, 3 ] == 'object'
         showproperties( 0 )
      endif
   endif   
return nil

function showproperties( nParent )
   local aItems := {}
   local aTable := {}
   local cWindowName := ''
   local cPath := ''
   local cKey := ''
   local cValue := ''
   local i := 0
   local nTabPage := 0
   local aLineData := {}
   local nChildKey := 0
   for i := 1 to hmg_len( aTabPages )
      if aTabPages[ i, 2 ] == nParent
         nTabPage := aTabPages[ i, 3 ]
         main.json.value := nTabPage
         return nil
      endif
   next i
   aTable := sql( oDB, 'select key, value, type, id, parent, path from jsoncontent where parent = ' +c2sql( nParent ) )
   if hmg_len( aTable ) > 0
      cPath := aTable[ 1, 6 ]
      for i := 1 to hmg_len( aTable )
         do case
         case aTable[ i, 3 ] == 'null'
            cValue := 'null'
            cKey := aTable[ i, 1 ]
         case aTable[ i, 3 ] == 'array'   
            cValue := ''
            cKey := '#[' + aTable[ i, 1 ] + ']'
         case aTable[ i, 3 ] == 'object'      
            cKey := '#{' + aTable[ i, 1 ] + '}'
            cValue := ''
         otherwise 
            cKey := aTable[ i, 1 ]
            cValue := any2str( aTable[ i, 2 ] )
         endcase   
         aadd( aItems, { any2str( aTable[ i, 4] ), any2str( aTable[ i, 5 ] ), cKey, cValue } )
      next i
   endif   
   nTabPage := hmg_len( aTabPages ) + 1
   aadd( aTabPages, { cPath, nParent, nTabPage } )
   cGridName := 'table' + alltrim( str( nTabPage ) )
   define grid &cGridName
      parent main
      row 10
      col 10
      width nDesktopWidth - 40
      height nDesktopHeight - 320
      headers { 'Ref.', 'Parent Ref.', 'Key', 'Value' }
      ondblclick propertyselected()
      widths { 100, 100, 170, 200 }
      items aItems 
   end grid   
   main.json.addpage( nTabPage, cPath )
   main.json.addcontrol( cGridName, nTabPage, 40, 10 )
   for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
      aLineData := getproperty( 'main', cGridName, 'ITEM', i )
      nChildKey := val( alltrim( aLineData[ 1 ] ) )
      do case
      case hb_usubstr( aLineData[ 3 ], 1, 2 ) == '#['
         showtable( nChildKey )
      case hb_usubstr( aLineData[ 3 ], 1, 2 ) == '#{'
         showproperties( nChildKey )
      endcase
   next i      
return nil

function showtable( nParent )
   local aTable := {}
   local aData := {}
   local aHeaders := {}
   local aLineData := {}
   local cWindowName := ''
   local aWidths := {} 
   local i, j, k 
   local aTable1 := {}
   local cPath := ''
   local cValue := ''
   local cKey := ''
   local cHeader := ''
   local aDynamicColors := {}
   local nTabPage := 0
   local nChildKey := 0
   local aRowParents := {}
   for i := 1 to hmg_len( aTabPages )
      if aTabPages[ i, 2 ] == nParent
         nTabPage := aTabPages[ i, 3 ]
         main.json.value := nTabPage
         return nil
      endif
   next i
   aTable1 := sql( oDB, 'select key, id, parent, path from jsoncontent where parent = ' + c2sql( nParent ) )
   nTotRows := hmg_len( aTable1 )
   if nTotRows > 0
      cPath := aTable1[ 1, 4 ]
      // no. of rows in the table
      for i := 1 to nTotRows 
         aTable := sql( oDB, 'select key, value, type, id  from jsoncontent where parent = ' + c2sql( aTable1[ i, 2 ] ) )
         if hmg_len( aTable ) > 0
            if i == 1
               aadd( aHeaders, 'Ref.' ) 
               aadd( aHeaders, 'Parent Ref.' )
               for j := 1 to hmg_len( aTable )
                  cHeader := aTable[ j, 1 ]
                  do case
                  case aTable[ j, 3 ] == 'array'   
                     cHeader := '#[' + cHeader + ']'
                  case aTable[ j, 3 ] == 'object'      
                     cHeader := '#{' + cHeader + '}'
                  endcase
                  aadd( aHeaders, cHeader )
               next j
            endif
            aLineData := {}
            asize( aLineData, hmg_len( aHeaders ) )
            afill( aLineData, '' )
            aLineData[ 1 ] := any2str( aTable1[ i, 2 ] ) 
            aLineData[ 2 ] := any2str( aTable1[ i, 3 ] ) 
            for j := 1 to hmg_len( aTable )
               cHeader := aTable[ j, 1 ]
               do case
               case aTable[ j, 3 ] == 'array'   
                  cHeader := '#[' + cHeader + ']'
               case aTable[ j, 3 ] == 'object'      
                  cHeader := '#{' + cHeader + '}'
               endcase   
               if ascan( aHeaders, cHeader ) == 0 // header not found add null data for others!
                  aadd( aHeaders, cHeader )
                  aadd( aLineData, '' ) // for current row!
                  for k := 1 to hmg_len( aData )
                     aadd( aData[ k ], '' )
                  next k
               endif
               nCol := ascan( aHeaders, cHeader )
               if nCol == 0 // still header not found! 
                  msgstop( 'Error!' )
                  return nil
               endif
               do case
               case aTable[ j, 3 ] == 'null'
                  cValue := 'null'
               case aTable[ j, 3 ] == 'array'   
                  cValue := any2str( aTable[ j, 4 ] ) 
               case aTable[ j, 3 ] == 'object'      
                  cValue := any2str( aTable[ j, 4 ] ) 
               otherwise 
                  cValue := any2str( aTable[ j, 2 ] )
               endcase   
               aLineData[ nCol ] := cValue 
            next j
            aadd( aData, aclone( aLineData ) )
         endif
      next i
      asize( aWidths, hmg_len( aHeaders ) )
      afill( aWidths, 100 )
      for i := 1 to hmg_len( aHeaders )
         do case
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#['
            aadd( aDynamicColors, { || aclone( aColorTable ) } )
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#{'
            aadd( aDynamicColors, { || aclone( aColorProperties ) } )
         otherwise
            aadd( aDynamicColors, { || { 255, 255, 255 } } )
         endcase
      next i
      nTabPage := hmg_len( aTabPages ) + 1
      aadd( aTabPages, { cPath, nParent, nTabPage } )
      cGridName := 'table' + alltrim( str( nTabPage ) )
      define grid &cGridName
         parent main
         row 10
         col 10
         width nDesktopWidth - 40
         height nDesktopHeight - 320
         headers aHeaders
         cellnavigation .t.
         widths aWidths
         ondblclick tablecolselected()
         dynamicbackcolor aDynamicColors
         items aData
      end grid   
      main.json.addpage( nTabPage, cPath )
      main.json.addcontrol( cGridName, nTabPage, 40, 10 )
      for j := 1 to hmg_len( aHeaders )
         asize( aRowParents, 0 )
         cCol := aHeaders[ j ]
         do case
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#['
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#{'
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         endcase
      next j      
   endif
   return nil
   
function propertyselected()
   local cWindowName := thiswindow.name
   local cControlName := this.name
   local nValue := this.value
   local nParent := 0
   if nValue > 0
      aLineData := this.item( nValue )
      nParent := val( alltrim( aLineData[ 1 ] ) )
      do case
      case hb_usubstr( aLineData[ 3 ], 1, 2 ) == '#['
         showtable( nParent )
      case hb_usubstr( aLineData[ 3 ], 1, 2 ) == '#{'
         showproperties( nParent )
      endcase
   endif
return nil
   
   
function tablecolselected
   local aLineNo := this.value
   local cPath := thiswindow.title
   local nRow := 0
   local nCol := 0
   local cCol := ''
   local cValue := ''
   local aRowParents := {}
   local i := 0
   if hmg_len( aLineNo ) == 2
      nRow := aLineNo[ 1 ] 
      nCol := aLineNo[ 2 ]
   endif
   if nRow > 0 .and. nCol > 0
      cValue := this.cell( nRow, nCol )
      cCol := this.header( nCol )
      do case
      case hb_usubstr( cCol, 1, 2 ) == '#[' 
         for i := 1 to this.itemcount
            cValue := this.cell( i, nCol )
            aadd( aRowParents, cValue )
         next i   
         showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
      case hb_usubstr( cCol, 1, 2 ) == '#{' 
         for i := 1 to this.itemcount
            cValue := this.cell( i, nCol )
            aadd( aRowParents, cValue )
         next i   
         showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
      otherwise
         return nil
      endcase
   endif
return nil   

function showtablerows( aRowParents, cTitle, nParent )
   local aTable := {}
   local i,j,k := 0
   local aHeaders := {}
   local aWidths := {}
   local aData := {}
   local aLineData := {}
   local cPath := ''
   local nCol := 0
   local cValue := ''
   local cWindowName := ''
   local cHeader := ''
   local aDynamicColors := {}
   local nTabPage := 0
   local cGridName := ''
   for i := 1 to hmg_len( aTabPages )
      if aTabPages[ i, 2 ] == nParent
         nTabPage := aTabPages[ i, 3 ]
         main.json.value := nTabPage
         return nil
      endif
   next i
   if hmg_len( aRowParents ) > 0
      for l := 1 to hmg_len( aRowParents )
         nRowID := val( alltrim( aRowParents[ l ] ) )
         aTable1 := sql( oDB, 'select key, id, parent, path from jsoncontent where parent = ' + c2sql( nRowID ) )
         nTotRows := hmg_len( aTable1 )
         if nTotRows > 0   
         // no. of rows in the child table
            for i := 1 to nTotRows
               aTable := sql( oDB, 'select key, value, type, id  from jsoncontent where parent = ' + c2sql( aTable1[ i, 2 ] ) )
               if hmg_len( aTable ) > 0
                  if hmg_len( aData ) == 0 // first row
                     aadd( aHeaders, 'Ref.' ) 
                     aadd( aHeaders, 'Parent Ref.' )
                     for j := 1 to hmg_len( aTable )
                        cHeader := aTable[ j, 1 ]
                        do case
                        case aTable[ j, 3 ] == 'array'   
                           cHeader := '#[' + cHeader + ']'
                        case aTable[ j, 3 ] == 'object'      
                           cHeader := '#{' + cHeader + '}'
                        endcase   
                        aadd( aHeaders, cHeader )
                     next j
                  endif
                  aLineData := {}
                  asize( aLineData, hmg_len( aHeaders ) )
                  afill( aLineData, '' )
                  aLineData[ 1 ] := any2str( aTable1[ i, 2 ] ) 
                  aLineData[ 2 ] := any2str( aTable1[ i, 3 ] ) 
                  for j := 1 to hmg_len( aTable )             
                     cHeader := aTable[ j, 1 ]
                     do case
                     case aTable[ j, 3 ] == 'array'   
                        cHeader := '#[' + cHeader + ']'
                     case aTable[ j, 3 ] == 'object'      
                        cHeader := '#{' + cHeader + '}'
                     endcase   
                     if ascan( aHeaders, cHeader ) == 0 // header not found add null data for others!
                        aadd( aHeaders, cHeader )
                        aadd( aLineData, '' ) //for current row
                        for k := 1 to hmg_len( aData )
                           aadd( aData[ k ], '' )
                        next k
                     endif
                     nCol := ascan( aHeaders, cHeader )
                     if nCol == 0 // still header not found! 
                        msgstop( 'Error!' )
                        return nil
                     endif
                     do case
                     case aTable[ j, 3 ] == 'null'
                        cValue := 'null'
                     case aTable[ j, 3 ] == 'array'   
                        cValue := any2str( aTable[ j, 4 ] ) 
                     case aTable[ j, 3 ] == 'object'      
                        cValue := any2str( aTable[ j, 4 ] ) 
                     otherwise 
                        cValue := any2str( aTable[ j, 2 ] )
                     endcase   
                     aLineData[ nCol ] := cValue 
                  next j
                  aadd( aData, aclone( aLineData ) )
               endif
            next i
         endif   
      next l
      asize( aWidths, hmg_len( aHeaders ) )
      afill( aWidths, 100 )
      for i := 1 to hmg_len( aHeaders )
         do case
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#['
            aadd( aDynamicColors, { || aclone( aColorTable ) } )
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#{'
            aadd( aDynamicColors, { || aclone( aColorProperties ) } )
         otherwise
            aadd( aDynamicColors, { || { 255, 255, 255 } } )
         endcase
      next i
      nTabPage := hmg_len( aTabPages ) + 1
      aadd( aTabPages, { cTitle, nParent, nTabPage } )
      cGridName := 'table' + alltrim( str( nTabPage ) )
      define grid &cGridName
         parent main
         row 10
         col 10
         width nDesktopWidth - 40
         height nDesktopHeight - 320
         headers aHeaders
         cellnavigation .t.
         dynamicbackcolor aDynamicColors
         widths aWidths
         ondblclick tablecolselected()
         items aData
      end grid   
      main.json.addpage( nTabPage, cTitle )
      main.json.addcontrol( cGridName, nTabPage, 40, 10 )
      for j := 1 to hmg_len( aHeaders )
         asize( aRowParents, 0 )
         cCol := aHeaders[ j ]
         do case
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#['
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#{'
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         endcase
      next j      
   endif      
   return nil
   
function showtableproperties( aRowParents, cTitle, nParent )   
   local aTable := {}
   local i,j,k := 0
   local aHeaders := {}
   local aWidths := {}
   local aData := {}
   local aLineData := {}
   local cPath := ''
   local nCol := 0
   local cValue := ''
   local cGridName := ''
   local aDynamicColors := {}
   local nTabPage := 0
   for i := 1 to hmg_len( aTabPages )
      if aTabPages[ i, 2 ] == nParent
         nTabPage := aTabPages[ i, 3 ]
         main.json.value := nTabPage
         return nil
      endif
   next i
   if hmg_len( aRowParents ) > 0
      for i := 1 to hmg_len( aRowParents )
         nRowID := val( alltrim( aRowParents[ i ] ) )
         aTable := sql( oDB, 'select key, value, type, id  from jsoncontent where parent = ' + c2sql( nRowId ) )
         if hmg_len( aTable ) > 0
            if hmg_len( aData ) == 0 // first row
               aadd( aHeaders, 'Parent Ref.' )
               for j := 1 to hmg_len( aTable )
                  cHeader := aTable[ j, 1 ]
                  do case
                  case aTable[ j, 3 ] == 'array'   
                     cHeader := '#[' + cHeader + ']'
                  case aTable[ j, 3 ] == 'object'      
                     cHeader := '#{' + cHeader + '}'
                  endcase   
                  aadd( aHeaders, cHeader )
               next j
            endif
            aLineData := {}
            asize( aLineData, hmg_len( aHeaders ) )
            afill( aLineData, '' )
            aLineData[ 1 ] := any2str( nRowID ) 
            for j := 1 to hmg_len( aTable )             
               cHeader := aTable[ j, 1 ]
               do case
               case aTable[ j, 3 ] == 'array'   
                  cHeader := '#[' + cHeader + ']'
               case aTable[ j, 3 ] == 'object'      
                  cHeader := '#{' + cHeader + '}'
               endcase   
               if ascan( aHeaders, cHeader ) == 0 // header not found add null data for others!
                  aadd( aHeaders, cHeader )
                  aadd( aLineData, '' ) //for current row
                  for k := 1 to hmg_len( aData )
                     aadd( aData[ k ], '' )
                  next k
               endif
               nCol := ascan( aHeaders, cHeader )
               if nCol == 0 // still header not found! 
                  msgstop( 'Error!' )
                  return nil
               endif
               do case
               case aTable[ j, 3 ] == 'null'
                  cValue := 'null'
               case aTable[ j, 3 ] == 'array'   
                  cValue := any2str( aTable[ j, 4 ] )
               case aTable[ j, 3 ] == 'object'      
                  cValue := any2str( aTable[ j, 4 ] )
               otherwise 
                  cValue := any2str( aTable[ j, 2 ] )
               endcase   
               aLineData[ nCol ] := cValue 
            next j
            aadd( aData, aclone( aLineData ) )
         endif
      next i
      asize( aWidths, hmg_len( aHeaders ) )
      afill( aWidths, 100 )
      for i := 1 to hmg_len( aHeaders )
         do case
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#['
            aadd( aDynamicColors, { || aclone( aColorTable ) } )
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#{'
            aadd( aDynamicColors, { || aclone( aColorProperties ) } )
         otherwise
            aadd( aDynamicColors, { || { 255, 255, 255 } } )
         endcase
      next i
      nTabPage := hmg_len( aTabPages ) + 1
      aadd( aTabPages, { cTitle, nParent, nTabPage } )
      cGridName := 'table' + alltrim( str( nTabPage ) )
      define grid &cGridName
         parent main
         row 10
         col 10
         width nDesktopWidth - 40
         height nDesktopHeight - 320
         headers aHeaders
         cellnavigation .t.
         dynamicbackcolor aDynamicColors
         widths aWidths
         ondblclick tablecolselected()
         items aData
      end grid   
      main.json.addpage( nTabPage, cTitle )
      main.json.addcontrol( cGridName, nTabPage, 40, 10 )
      for j := 1 to hmg_len( aHeaders )
         asize( aRowParents, 0 )
         cCol := aHeaders[ j ]
         do case
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#['
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#{'
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         endcase
      next j      
   endif      
return nil
   
    
function any2str( item )
   local cItem := ''
   local i 
   do case
   case valtype( item ) == 'C'
      return item
   case valtype( item ) == 'M'
      return item
   case valtype( item ) == 'D'
      return dtoc( item )
   case valtype( item ) == 'N'
      return alltrim( str( item ) )
   case valtype( item ) == 'L'
      return iif( item, 'Y', 'N' )
   case valtype( item ) == 'A'
      cItem := '{'
      for i := 1 to hmg_len( item )
         cItem := cItem + any2str( item[ i ] )
         if i < hmg_len( item )
            cItem := cItem + ', '
         endif
      next i
      cItem := cItem + '}'
      return cItem
   otherwise 
      return ''
   endcase
return nil    